Package net.sf.saxon.tree.iter

## Class AtomizingIterator

- java.lang.Object
- - net.sf.saxon.tree.iter.AtomizingIterator

- All Implemented Interfaces:
    `java.io.Closeable`, `java.lang.AutoCloseable`, `SequenceIterator`

      public class AtomizingIterator
      extends java.lang.Object
      implements SequenceIterator

  AtomizingIterator returns the atomization of an underlying sequence supplied as an iterator. We use a specialist class rather than a general-purpose MappingIterator for performance, especially as the relationship of items in the result sequence to those in the base sequence is often one-to-one.

  This AtomizingIterator is capable of handling list-typed nodes whose atomized value is a sequence of more than one item. When it is known that all input will be untyped, an `UntypedAtomizingIterator` is used in preference.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.om.SequenceIterator

      `SequenceIterator.Property`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AtomizingIterator​(SequenceIterator base)` | Construct an AtomizingIterator that will atomize the values returned by the base iterator.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `close()` | Close the iterator.
    `AtomicValue` | `next()` | Get the next item in the sequence.
    `void` | `setRoleDiagnostic​(RoleDiagnostic role)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.SequenceIterator

      `forEachOrFail, getProperties, materialize`

- - ### Constructor Detail

    - #### AtomizingIterator

          public AtomizingIterator​(SequenceIterator base)

      Construct an AtomizingIterator that will atomize the values returned by the base iterator.
      Parameters:
        `base` - the base iterator

  - ### Method Detail

    - #### setRoleDiagnostic

          public void setRoleDiagnostic​(RoleDiagnostic role)

    - #### next

          public AtomicValue next()
                           throws XPathException

      Description copied from interface: `SequenceIterator`
      Get the next item in the sequence. This method changes the state of the iterator.
      Specified by:
        `next` in interface `SequenceIterator`
      Returns:
        the next item, or null if there are no more items. Once a call on next() has returned null, no further calls should be made. The preferred action for an iterator if subsequent calls on next() are made is to return null again, and all implementations within Saxon follow this rule.
      Throws:
        `XPathException` - if an error occurs retrieving the next item

    - #### close

          public void close()

      Description copied from interface: `SequenceIterator`
      Close the iterator. This indicates to the supplier of the data that the client does not require any more items to be delivered by the iterator. This may enable the supplier to release resources. After calling close(), no further calls on the iterator should be made; if further calls are made, the effect of such calls is undefined.

      For example, the iterator returned by the unparsed-text-lines() function has a close() method that causes the underlying input stream to be closed, whether or not the file has been read to completion.

      Closing an iterator is important when the data is being "pushed" in another thread. Closing the iterator terminates that thread and means that it needs to do no additional work. Indeed, failing to close the iterator may cause the push thread to hang waiting for the buffer to be emptied.

      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `SequenceIterator`